clc;clear;close all;

output_dir = pwd;

load('/media/arash/SSD128/Post proc/inputs/T19/i_area_t.mat')
load('/media/arash/SSD128/Post proc/inputs/T19/i_heff_t.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/ITP_ice_vel_filtered.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')
load ('/media/arash/SSD128/Post proc/inputs/constants/2006_2013.mat')

% n = 13 is ITP 35
load('itp_35_post_36km_mcphee.mat')

% itp_35 = 13;

% Reshaping the lon-lat
lat_t_r=reshape(lat_t,size(lat_t,1)*size(lat_t,2),1);
lon_t_r=reshape(lon_t,size(lon_t,1)*size(lon_t,2),1);

lat_t_r_sat = reshape(sat_lat,size(sat_lat,1)*size(sat_lat,2),1);
lon_t_r_sat = reshape(sat_lon,size(sat_lon,1)*size(sat_lon,2),1);

% constants
sim_start_date=datenum(2006,1,1);
R = earthRadius;
dt=24*3600;

% reading from ITP_ice_vel instead of traj_start
% for i = itp_35
%     
%     start_date = itp_date_obs{1,i}(1,1);
%     end_date = itp_date_obs{1,i}(1,end);
%     itp_lon = itp_lon_obs{1,i};
%     itp_lat = itp_lat_obs{1,i};
%     
% end
start_date = data.time(1);
end_date = data.time(end);
itp_lon = data.lon;
itp_lat = data.lat;

record_start = start_date-sim_start_date;
record_end = end_date-sim_start_date;

% setting recorder
ii = 1;
for n=record_start:record_end
    
    SI_sat(:,:,ii) =reshape(double(z{n}),size(sat_lat,1)*size(sat_lat,2),1);
    SI_area(:,:,ii)=reshape(double(i_area_t(:,:,n)),size(lat_t,1)*size(lat_t,2),1);
    SI_heff(:,:,ii)=reshape(double(i_heff_t(:,:,n)),size(lat_t,1)*size(lat_t,2),1);
    
    
    %projecting forward ice values
    [x_t_r ,y_t_r ,SI_area_z] = mfwdtran(mstruct,lat_t_r,lon_t_r,SI_area(:,:,ii));
    [~ ,~ ,SI_heff_z] = mfwdtran(mstruct,lat_t_r,lon_t_r,SI_heff(:,:,ii));
    [x_t_r_s ,y_t_r_s ,SI_sat_z] = mfwdtran(mstruct,lat_t_r_sat,lon_t_r_sat,SI_sat(:,:,ii));
    
    
    
    %making the interpolation surface
    surf_ice=scatteredInterpolant(x_t_r,y_t_r,SI_area_z,'linear','nearest');
    surf_ice_h = scatteredInterpolant(x_t_r,y_t_r,SI_heff_z,'linear','nearest');
    surf_ice_sat = scatteredInterpolant(x_t_r_s,y_t_r_s,SI_sat_z,'linear','nearest');
    
    %projecting itp_lat lon forward
    
    [p_x ,p_y]  = mfwdtran(mstruct,itp_lat(ii),itp_lon(ii));
    
    % reading the projection
    itp_63_ice_a(ii) = surf_ice(p_x ,p_y);
    itp_63_ice_sat(ii) = surf_ice_sat(p_x ,p_y);
    itp_63_ice_h(ii) = surf_ice_h(p_x ,p_y);
    
    ii = ii+1;
    n
end

% plotting
subplot(2,1,1)

plot(record_start+sim_start_date:record_end+sim_start_date,itp_63_ice_a)
datetick('x','mmm')
hold on
plot(record_start+sim_start_date:record_end+sim_start_date,itp_63_ice_sat/100)
axis tight
% ylim ([0.5 1])
legend('Simulated','Observed','orientation','horizental','location','south')
ylabel('ice area fraction')
ylim ([0 1])
grid minor

subplot(2,1,2)
plot(record_start+sim_start_date:record_end+sim_start_date,itp_63_ice_h)
datetick('x','mmm')
axis tight
grid minor
ylabel('ice thickness')
