clear, close all,clc
addpath('local_fun/')
%values used in the code
my_offset = -0;
dt_1 = 3600*24;
a_block_1 = 1;
dt_2 = 3600*6;
% a_block_2 = 4*a_block_1;
a_block_2 = 1;
depth_block = [5 60];
h = depth_block(end) - depth_block(1);
low_pass1 = 4;
low_pass2 = low_pass1*4;

warning('off','MATLAB:interp1:NaNstrip');

load('itp_35_post_36km_mcphee.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');
sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);
% calculating ML
for n = 1:size(data.time,2)
    
    [data.ml2(n),data.first_val(n),~,data.ml(n)] = mld_finder(data.p(:,n),data.rho(:,n),0.1,0.02,0.2);
    tmp = squeeze(sim.rho(:,n));
    tmp(sim.dz<data.first_val(n)) = NaN;
%     [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,sim.rho(:,n),0.1,0.02,0.2);
        [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,tmp,0.1,0.02,0.2);
end
%%%low pass
for k=1:size(data.u,1)
    data.u(k,:) = my_lowpass(data.u(k,:),low_pass1);
    data.v(k,:) = my_lowpass(data.v(k,:),low_pass1);
end

for k=1:size(sim.u,1)
    sim.u(k,:) = my_lowpass(sim.u(k,:),low_pass1);
    sim.v(k,:) = my_lowpass(sim.v(k,:),low_pass1);
end

sim_mcphee = sim;
clear sim
data_old = data;

load('itp_35_post_36km_old.mat')
sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');
sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);
% calculating ML
for n = 1:size(data.time,2)
    
    [data.ml2(n),data.first_val(n),~,data.ml(n)] = mld_finder(data.p(:,n),data.rho(:,n),0.1,0.02,0.2);
    tmp = squeeze(sim.rho(:,n));
    tmp(sim.dz<data.first_val(n)) = NaN;
%     [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,sim.rho(:,n),0.1,0.02,0.2);
            [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,tmp,0.1,0.02,0.2);
    
end
%%% low pass
for k=1:size(data.u,1)
    data.u(k,:) = my_lowpass(data.u(k,:),low_pass1);
    data.v(k,:) = my_lowpass(data.v(k,:),low_pass1);
end

for k=1:size(sim.u,1)
    sim.u(k,:) = my_lowpass(sim.u(k,:),low_pass1);
    sim.v(k,:) = my_lowpass(sim.v(k,:),low_pass1);
end

sim_old = sim;
clear sim

load('itp_35_post_9k.mat')
% load('itp_35_post_preMcphee.mat')

sim.dz = -ncread('/media/arash/SSD512/Post proc/inputs/T40/grid.glob.nc','RC');


sim.rho = gsw_rho(sim.s,sim.T,sim.dz);
data.rho = gsw_rho(data.s,data.T,data.p);
% calculating ML
for n = 1:size(data.time,2)
    
    [data.ml2(n),data.first_val(n),~,data.ml(n)] = mld_finder(data.p(:,n),data.rho(:,n),0.1,0.02,0.2);
    tmp = squeeze(sim.rho(:,n));
    tmp(sim.dz<data.first_val(n)) = NaN;
%     [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,9k.rho(:,n),0.1,0.02,0.2);
        [sim.ml2(n),sim.first_val(n),~,sim.ml(n)] = mld_finder(sim.dz,tmp,0.1,0.02,0.2);
    
end

sim_9km = sim;
data_9km = data;

%
%here I changed 6 hours to 24 hours
%

t_vec = sim_old.time;
for n = 1:size(sim_9km.T,1)
    foo.T(n,:) = interp1(sim_9km.time,sim_9km.T(n,:),t_vec);
    foo.s(n,:) = interp1(sim_9km.time,sim_9km.s(n,:),t_vec);
    foo.u(n,:) = interp1(sim_9km.time,sim_9km.u(n,:),t_vec);
    foo.v(n,:) = interp1(sim_9km.time,sim_9km.v(n,:),t_vec);
    foo.rho(n,:) = interp1(sim_9km.time,sim_9km.rho(n,:),t_vec);
end
sim_9km.ai = interp1(sim_9km.time,sim_9km.ai,t_vec);
sim_9km.hi = interp1(sim_9km.time,sim_9km.hi,t_vec);

foo.ml = interp1(sim_9km.time,sim_9km.ml,t_vec);
sim_9km.time = t_vec;
data_9km = data_old;
sim_9km.T = foo.T; sim_9km.s = foo.s; sim_9km.u = foo.u;
sim_9km.v = foo.v; sim_9km.rho = foo.rho; sim_9km.ml = foo.ml;

% plotting rho figure 1
figure
subplot 511;hold on
my_pcolor_rho_data(data.time,data.p,data.rho,1022.5,data.first_val);
% contour(data.time,data.p,data.rho,1022)
title('data')

subplot 512
my_pcolor_rho(sim_mcphee.time,sim.dz,sim_mcphee.rho,1022.5)
title('A1')
ylabel('depth (m)')
% subplot 413
% my_pcolor_rho(sim_old.time,sim.dz,sim_old.rho);
% title('sim old')

subplot 513
my_pcolor_rho(sim_9km.time,sim.dz,sim_9km.rho,1022.5);
title('A2')

subplot 514
plot(sim_9km.time,sim_mcphee.ai);hold on
plot(sim_9km.time,sim_9km.ai)
datetick('x','mmm');axis tight;
ylim ([0.8 1]);ylabel('SI fraction');xlabel('Time')
legend('A1','A2')
% plotting ML figure 2

subplot 515
plot(sim_9km.time,sim_mcphee.hi);hold on
plot(sim_9km.time,sim_9km.hi)
datetick('x','mmm');axis tight;
% ylim ([0.8 1])
;ylabel('SI thickness (m)');xlabel('Time')
legend('A1','A2')

figure
plot(data.time,data.ml,'k');hold on;
% plot(sim_old.time,sim_old.ml);
plot(sim_old.time,sim_mcphee.ml,'b');
plot(sim_9km.time,sim_9km.ml,'r');
datetick('x','mmm');axis tight;
ylim ([0 50]);ylabel('MLD (m)');xlabel('Time')
set(gca,'ydir','reverse')
legend('data','A1','A2')
% title('ML (m)')





