clear, close all,clc

output_address = pwd

% case_id = 'T40';
% input_address =(sprintf('/media/arash/SSD512/Post proc/inputs/%s',case_id))
input_address = ('/media/arash/Dell Portable Hard Drive/T32')
cd(input_address)

%loading inputs from the code
load ('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')
load('ITP35_d150f_Sept12d_smth.mat');

s_start = datenum(2006,1,1);
s_end = datenum(2013,9,1);
s_t_vec = s_start:s_end;
lat = lat_t;lon = lon_t;
clear lat_t lon_t

d_tstart = d150.tstart;
[x,y] = mfwdtran(mstruct,lat,lon);

d.lat = interp1(d_tstart,d150.lat,s_t_vec);
d.lon = interp1(d_tstart,d150.lon,s_t_vec);
d.ui = interp1(d_tstart,d150.uice,s_t_vec);
d.vi = interp1(d_tstart,d150.vice,s_t_vec);

d.time = s_t_vec;

for i = 1:size(d150.u,1)
    
    d.u(i,:) = interp1(d_tstart,d150.u(i,:),s_t_vec);
    d.v(i,:) = interp1(d_tstart,d150.v(i,:),s_t_vec);
    d.T(i,:) = interp1(d_tstart,d150.T(i,:),s_t_vec);
    d.s(i,:) = interp1(d_tstart,d150.s(i,:),s_t_vec);
    d.p(i,:) = interp1(d_tstart,d150.p(i,:),s_t_vec);
    
end

warning('off','MATLAB:MatFile:OlderFormat')
m = 0;
for n = 1:length(d.lat)
    if ~isnan(d.lat(n))
        m = m+1;
        display(sprintf('step %d of %d',...
            m,sum(~isnan(d.lat))))
        u_m = matfile('u_field_m_t.mat');
        v_m = matfile('v_field_m_t.mat');
        T_m = matfile('theta_field_t.mat');
        s_m = matfile('salt_field_t.mat');
        ui_m = matfile('iu_field_m_t.mat');
        vi_m = matfile('iv_fienld_m_t.mat');
        hi_m = matfile('i_heff_t.mat');
        ai_m = matfile('i_area_t.mat');
        eta_m = matfile('etan_t.mat');
        u_r = squeeze(u_m.u_field_m_t(:,:,:,n));
        v_r = squeeze(v_m.v_field_m_t(:,:,:,n));
        T = squeeze(T_m.theta_field_t(:,:,:,n));
        s = squeeze(s_m.salt_field_t(:,:,:,n));
        ui_r = squeeze(ui_m.iu_field_m_t(:,:,n));
        vi_r = squeeze(vi_m.iv_field_m_t(:,:,n));
        hi = squeeze(hi_m.i_heff_t(:,:,n));
        ai = squeeze(ai_m.i_area_t(:,:,n));
        eta = squeeze(eta_m.etan_t(:,:,n));
        
        [x0,y0] = mfwdtran(mstruct,d.lat(n),d.lon(n));
        my_DEL = griddata_preprocess(x,y,x0,y0);
        for i = 1:size(u_r,3)
            [x_z,y_z,u_r_z] = mfwdtran(mstruct,lat,lon,squeeze(u_r(:,:,i)));
            [~,~,v_r_z] = mfwdtran(mstruct,lat,lon,squeeze(v_r(:,:,i)));
            [~,~,T_z] = mfwdtran(mstruct,lat,lon,squeeze(T(:,:,i)));
            [~,~,s_z] = mfwdtran(mstruct,lat,lon,squeeze(s(:,:,i)));
            sim.T(i,m) = griddata_fast(my_DEL,T_z);
            sim.s(i,m) = griddata_fast(my_DEL,s_z);
            sim.u(i,m) = griddata_fast(my_DEL,u_r_z);
            sim.v(i,m) = griddata_fast(my_DEL,v_r_z);
        end
        [~,~,ui_r_z] = mfwdtran(mstruct,lat,lon,ui_r);
        [~,~,vi_r_z] = mfwdtran(mstruct,lat,lon,vi_r);
        [~,~,hi_z] = mfwdtran(mstruct,lat,lon,hi);
        [~,~,ai_z] = mfwdtran(mstruct,lat,lon,ai);
        [~,~,eta_z] = mfwdtran(mstruct,lat,lon,eta);
        sim.ui(1,m) = griddata_fast(my_DEL,ui_r_z);
        sim.vi(1,m) = griddata_fast(my_DEL,vi_r_z);
        sim.hi(1,m) = griddata_fast(my_DEL,hi_z);
        sim.ai(1,m) = griddata_fast(my_DEL,ai_z);
        sim.eta(1,m) = griddata_fast(my_DEL,eta_z);
        
        sim.time(m) = s_t_vec(n);
        sim.lat(m) = d.lat(n);
        sim.lon(m) = d.lon(n);
    end
end
data.T = d.T(:,~isnan(d.lat));
data.p = d.p(:,~isnan(d.lat));
data.s = d.s(:,~isnan(d.lat));
data.u = d.u(:,~isnan(d.lat));
data.v = d.v(:,~isnan(d.lat));
data.time = d.time(~isnan(d.lat));
data.lon = d.lon(~isnan(d.lat));
data.lat = d.lat(~isnan(d.lat));
data.ui = d.ui(~isnan(d.lat));
data.vi = d.vi(~isnan(d.lat));
cd(output_address)
save('itp_35_post_36km_old','sim','data');