clear,close all,clc
addpath(genpath('/media/arash/SSD512/Post proc/fwaterPoster_newMCphee/mcphee/Mooring'));

output_address = pwd;
% input_address = '/media/arash/Arash2/T34_results/output';
input_address = '/media/arash/Arash2/T41_resutls/output';

load('/media/arash/Arash1/T34_post/code_constants/my_grid');
load('/media/arash/Arash1/T34_post/code_constants/msturuct');
cd  (output_address)
cd raw_in/
mooring_data = read_mooring;
cd ..
%setting mooring into 6 hour frequency floor(hour/4) run unique then. or
%interp to a s_t_vec
mooring.d.u  = mooring_data.u;
mooring.d.v  = mooring_data.v;
mooring.loc = mooring_data.location;
mooring.d.dz = mooring_data.dz;
mooring.d.time = mooring_data.time;
mooring.name = mooring_data.name;

clear mooring_data;

for m_id = 1:length(mooring.loc)
    
    mooring.d.start_time{m_id} = datenum(mooring.d.time{m_id}(1,:));
    mooring.d.end_time{m_id} = datenum(mooring.d.time{m_id}(end,:));
    
    
end


s_tstart_1 = datenum(2009,1,0);
s_tstart_2 = datenum(2010,1,0);
s_tstart_3 = datenum(2011,1,0);
s_tstart_4 = datenum(2012,1,0);
s_tend = datenum(2013,1,0)-(1/4);
% s_tend = datenum(2012,1,0)-(1/4);

s_t_vec = s_tstart_1:(1/4):s_tend;
[x,y] = mfwdtran(mstruct,lat,lon);
mooring.s.time = s_t_vec;
for n = 1:length(mooring.loc)
    [x0, y0] = mfwdtran(mstruct,...
        mooring.loc{n}(1),mooring.loc{n}(2));
    my_DEL{n} = griddata_preprocess(x,y,x0,y0);
end

cd (input_address)
for n = 1:length(s_t_vec)
    
    if (s_t_vec(n) >= s_tstart_1 && s_t_vec(n) < s_tstart_2)
        u_m = matfile('UVEL.0002980800.glob.mat');
        v_m = matfile('VVEL.0002980800.glob.mat');
        s_m = matfile('SALT.0002980800.glob.mat');
        T_m = matfile('THETA.0002980800.glob.mat');
        cont = n;
    elseif (s_t_vec(n) >= s_tstart_2 && s_t_vec(n) < s_tstart_3)
        u_m = matfile('UVEL.0003156000.glob.mat');
        v_m = matfile('VVEL.0003156000.glob.mat');
        s_m = matfile('SALT.0003156000.glob.mat');
        T_m = matfile('THETA.0003156000.glob.mat');
        cont = n - ((s_tstart_2-s_tstart_1)*4);
        
    elseif (s_t_vec(n) >= s_tstart_3 && s_t_vec(n) < s_tstart_4)
        u_m = matfile('UVEL.0003331200.glob.mat');
        v_m = matfile('VVEL.0003331200.glob.mat');
        s_m = matfile('SALT.0003331200.glob.mat');
        T_m = matfile('THETA.0003331200.glob.mat');
        cont = n - ((s_tstart_3-s_tstart_1)*4);
        
    else
        u_m = matfile('UVEL.0003506400.glob.mat');
        v_m = matfile('VVEL.0003506400.glob.mat');
        s_m = matfile('SALT.0003506400.glob.mat');
        T_m = matfile('THETA.0003506400.glob.mat');
        cont = n - ((s_tstart_4-s_tstart_1)*4);
        
    end
    u = squeeze(u_m.final_m(:,:,1:30,cont));
    v = squeeze(v_m.final_m(:,:,1:30,cont));
    s = squeeze(s_m.final_m(:,:,1:30,cont));
    T = squeeze(T_m.final_m(:,:,1:30,cont));
   
    for m_id = 1:length(mooring.loc)
        if (s_t_vec(n)>= mooring.d.start_time{m_id} && s_t_vec(n) <= mooring.d.end_time{m_id})
            for i = 1:size(u,3)
                [u_r(:,:,i),v_r(:,:,i)] = getuEvN_uXvY(squeeze(u(:,:,i)),squeeze(v(:,:,i)),AngleCS,AngleSN,lon,lat,-1000,1,0);
                [~,~,u_r_z] = mfwdtran(mstruct,lat,lon,squeeze(u_r(:,:,i)));
                [~,~,v_r_z] = mfwdtran(mstruct,lat,lon,squeeze(v_r(:,:,i)));
                [~,~,s_z] = mfwdtran(mstruct,lat,lon,squeeze(s(:,:,i)));
                [~,~,T_z] = mfwdtran(mstruct,lat,lon,squeeze(T(:,:,i)));
                
                mooring.s.u{m_id}(n,i) = griddata_fast(my_DEL{m_id},u_r_z);
                mooring.s.v{m_id}(n,i) = griddata_fast(my_DEL{m_id},v_r_z);
                mooring.s.s{m_id}(n,i) = griddata_fast(my_DEL{m_id},s_z);
                mooring.s.T{m_id}(n,i) = griddata_fast(my_DEL{m_id},T_z);
                
            end
        end
    end
    display(sprintf('%d of %d \n',n,length(s_t_vec)))
    
end

mooring.s.dz = RC(1:30);

cd(output_address)
cd local_out/
mooring_9km=mooring;
save('mooring_9km','mooring');


