clear,close all,clc
addpath(genpath('/media/arash/SSD512/Post proc/fwaterPoster_newMCphee/mcphee/Mooring'));

output_address = pwd;
% input_address = '/media/arash/Arash2/T34_results/output';
input_address = ('/media/arash/SSD512/Post proc/inputs/T40');




load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')
load ('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')

cd  (output_address)
cd raw_in/
mooring_data = read_mooring;
cd ..
%setting mooring into 6 hour frequency floor(hour/4) run unique then. or
%interp to a s_t_vec
mooring.d.u  = mooring_data.u;
mooring.d.v  = mooring_data.v;
mooring.loc = mooring_data.location;
mooring.d.dz = mooring_data.dz;
mooring.d.time = mooring_data.time;
mooring.name = mooring_data.name;

clear mooring_data;

for m_id = 1:length(mooring.loc)
    
    mooring.d.start_time{m_id} = datenum(mooring.d.time{m_id}(1,:));
    mooring.d.end_time{m_id} = datenum(mooring.d.time{m_id}(end,:));
    
end


s_start = datenum(2006,1,1);
s_end = datenum(2013,9,1);
s_t_vec = s_start:s_end;
lat = lat_t;lon = lon_t;
[x,y] = mfwdtran(mstruct,lat,lon);
mooring.s.time = s_t_vec;

for n = 1:length(mooring.loc)
    [x0, y0] = mfwdtran(mstruct,...
        mooring.loc{n}(1),mooring.loc{n}(2));
    my_DEL{n} = griddata_preprocess(x,y,x0,y0);
end

cd (input_address)
u_m = matfile('u_field_m_t.mat');
v_m = matfile('v_field_m_t.mat');
T_m = matfile('theta_field_t.mat');
s_m = matfile('salt_field_t.mat');

for n = 1:length(s_t_vec)
    
    cont = n;
    
    u = squeeze(u_m.u_field_m_t(:,:,1:30,cont));
    v = squeeze(v_m.v_field_m_t(:,:,1:30,cont));
    s = squeeze(s_m.salt_field_t(:,:,1:30,cont));
    T = squeeze(T_m.theta_field_t(:,:,1:30,cont));
    
    for m_id = 1:length(mooring.loc)
        if (s_t_vec(n)>= mooring.d.start_time{m_id} && s_t_vec(n) <= mooring.d.end_time{m_id})
            for i = 1:size(u,3)
                u_r(:,:,i) = u(:,:,i);
                v_r(:,:,i) = v(:,:,i);
                [~,~,u_r_z] = mfwdtran(mstruct,lat,lon,squeeze(u_r(:,:,i)));
                [~,~,v_r_z] = mfwdtran(mstruct,lat,lon,squeeze(v_r(:,:,i)));
                [~,~,s_z] = mfwdtran(mstruct,lat,lon,squeeze(s(:,:,i)));
                [~,~,T_z] = mfwdtran(mstruct,lat,lon,squeeze(T(:,:,i)));               
                mooring.s.u{m_id}(n,i) = griddata_fast(my_DEL{m_id},u_r_z);
                mooring.s.v{m_id}(n,i) = griddata_fast(my_DEL{m_id},v_r_z);
                mooring.s.s{m_id}(n,i) = griddata_fast(my_DEL{m_id},s_z);
                mooring.s.T{m_id}(n,i) = griddata_fast(my_DEL{m_id},T_z);
            end
        end
    end
    display(sprintf('%d of %d \n',n,length(s_t_vec)))
    
end

% mooring.s.dz = RC(1:30);
mooring_36km = mooring;
cd(output_address)
cd local_out/
save('mooring_36km','mooring_36km');


