clear;clc;close all;
load('local_out/mooring_final_rho.mat')
scrsz = get(groot,'ScreenSize');
% grad_cut = 0.02 , rho_cut = 0.01 , mld_shaw_fraction = 0.2
grad_cut = 0.02;rho_cut= 0.01;shaw_f = 0.2;
for n = 1:3
    for i = 1:size(mooring_final.s2.rho{n},2)
        [~,~,~,mooring_final.s2.mld{n}(i)] = ...
            mld_finder(mooring_final.s2.dz,mooring_final.s2.rho{n}(:,i),...
            grad_cut,rho_cut,shaw_f);
        [~,~,~,mooring_final.s9.mld{n}(i)] = ...
            mld_finder(-mooring_final.s9.dz,mooring_final.s9.rho{n}(:,i),...
            grad_cut,rho_cut,shaw_f);
        [~,~,~,mooring_final.s36.mld{n}(i)] = ...
            mld_finder(-mooring_final.s36.dz,mooring_final.s36.rho{n}(:,i),...
            grad_cut,rho_cut,shaw_f);
    end
end

for n = 1:3
    figure('Position',[1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/4])
    plot(mooring_final.Time,mooring_final.s2.mld{n},'k');hold on;
    plot(mooring_final.Time,mooring_final.s9.mld{n},'r');
    plot(mooring_final.Time,mooring_final.s36.mld{n},'b');
    datetick('x','mmm');legend('2km','9km','36km');
    set(gca,'ydir','reverse');ylim([0 50]);ylabel('MLD depth (m)');
    title(sprintf('mooring %s MLD',mooring_final.name{n}(7)))
    print(gcf,'-djpeg','-r 640',sprintf('figures/MLD %s',mooring_final.name{n}(7)))
end