clear all;clc;close all;fclose all;

% tic
input_address = pwd
cd (pwd)
load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')

%loading inputs from the code
% load ('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')
% load u_field_m_t.mat;
% load v_field_m_t.mat;
% load dz_new

do_itp = 1
while do_itp == 1
    load ('/media/arash/SSD128/Post proc/inputs/constants/ITP35_d150f_Sept12d_smth.mat')
    load ('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')
    load u_field_m_t.mat;
    load v_field_m_t.mat;
    load('/media/arash/SSD512/Post proc/inputs/constants/sim_depth.mat')
%     load dz_new
    % loading itp mav data
    itp_daily_post = 1;
    while itp_daily_post == 1
        itp_date = d150.tstart;
        
        itp_depth = d150.depth;
        itp_lon = d150.lon;
        itp_lat = d150.lat;
        itp_u = d150.u;
        itp_v = d150.v;
        itp_w = d150.w;
        
        % daily averaging the data
        
        date_vector = datevec(itp_date);
        [a1,b1,b1] = unique(date_vector(:,1:3),'rows');
        
        itp_date = datenum(a1);
        itp_lon = accumarray(b1,itp_lon,[],@nanmean);
        itp_lat = accumarray(b1,itp_lat,[],@nanmean);
        
        for ii = 1:size(itp_u,1)
            
            
            itp_u_temp(ii,:) = accumarray(b1,itp_u(ii,:),[],@nanmean);
            itp_v_temp(ii,:) = accumarray(b1,itp_v(ii,:),[],@nanmean);
            itp_w_temp(ii,:) = accumarray(b1,itp_w(ii,:),[],@nanmean);
            
        end
        
        itp_u = itp_u_temp;
        itp_v = itp_v_temp;
        itp_w = itp_w_temp;
        
        break
    end
    
    num_sim_date = size(u_field_m_t,4);
    num_ver_layer = size(u_field_m_t,3);
    sim_3d_start_date=datenum(2006,1,1)-1;
    
    setting_depth = 0;
    while setting_depth == 1
        dh(1) = 0;
        dh(2:size(dz_new,2)+1) = dz_new ;
        
        % tracers beside W are at half the depth incerements
        
        for i=1:num_ver_layer+1
            
            sim_depth_w(i)=sum(dh(1:i));
            
        end
        
        for i=1:num_ver_layer
            
            sim_depth(i)=(sim_depth_w(i)+sim_depth_w(i+1))/2;
            
        end
        
        break
    end
    
    % changing U and V format and stroing them at given date and layer
    
    for sim_date  = 1:num_sim_date
        
        
        
        for m=1:num_ver_layer
            
            u_field{sim_date,m}=u_field_m_t(:,:,m,sim_date);
            v_field{sim_date,m}=v_field_m_t(:,:,m,sim_date);
            
        end
        
    end
    
    clear u_field_m_t v_field_m_t
    
    
    % Reshaping simulation data
    for n=1:num_sim_date
        for m=1:num_ver_layer
            u_field{n,m} = reshape(double(u_field{n,m}),size(u_field{n,m},1)*size(u_field{n,m},2),1);
            v_field{n,m} = reshape(double(v_field{n,m}),size(v_field{n,m},1)*size(v_field{n,m},2),1);
        end
    end
    
    
    
    % Reshaping the lon-lat
    
    lat_t_r=reshape(lat_t,size(lat_t,1)*size(lat_t,2),1);
    lon_t_r=reshape(lon_t,size(lon_t,1)*size(lon_t,2),1);
    
    display('starting the steps')
    for n=1:num_sim_date
        display(sprintf('itp time step %d / 2801',n))
        
        sim_date = n+sim_3d_start_date;
        
        for m=1:num_ver_layer
            
            % interpolation and projection
            [x_t_r ,y_t_r ,u_z] = mfwdtran(mstruct, lat_t_r, lon_t_r, u_field{n,m});
            [x_t_r ,y_t_r ,v_z] = mfwdtran(mstruct, lat_t_r, lon_t_r, v_field{n,m});
            
            sim_u_surf = scatteredInterpolant(x_t_r ,y_t_r ,u_z,'linear','nearest');
            sim_v_surf = scatteredInterpolant(x_t_r ,y_t_r ,v_z,'linear','nearest');
            
            
            for o=1:length(itp_date)
                
                if itp_date(o) == sim_date
                    
                    [itp_x, itp_y] = mfwdtran(mstruct,itp_lat(o) ,itp_lon(o));
                    
                    itp_u_sim_temp{o}(m,1) = sim_u_surf(itp_x, itp_y);
                    itp_v_sim_temp{o}(m,1) = sim_v_surf(itp_x, itp_y);

                end
            end
            clear u_z v_z
            
        end
    end
    %     toc
    %
    
    % turning cell format to matrix again
    
    for n = 1:length(itp_v_sim_temp)
        for m = 1:length(itp_v_sim_temp{o})
            
            itp_u_sim(m,n) = itp_u_sim_temp{n}(m,1);
            itp_v_sim(m,n) = itp_v_sim_temp{n}(m,1);
            
        end
    end
    
    save ('itp_uv_sim','itp_date','itp_lat','itp_lon','itp_depth','sim_depth','itp_v_sim','itp_u_sim')
    clear
    break
end

do_mooring = 1
while do_mooring == 1
    
    load ('/media/arash/SSD128/Post proc/inputs/constants/mooring_data.mat')
    load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')
    load('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')
    load ('/meda/arash/SSD512/Post proc/inputs/constants/sim_depth.mat')


    load u_field_m_t.mat;
    load v_field_m_t.mat;
%     load dz_new
    % loading itp mav data
    mooring_daily_post = 1;
    while mooring_daily_post == 1
        
        
        % daily averaging the data
        for i = 1:length(mooring.name)
            
            date_vector = mooring.time{i};
            [a1,b1,b1] = unique(date_vector(:,1:3),'rows');
            
            mooring_date{i} = datenum(a1);
            mooring_lon{i} = mooring.location{1, i}(2);
            mooring_lat{i} = mooring.location{1, i}(1);
            
            for ii = 1:length(mooring.dz{1, i})
                
                
                mooring_u_temp{i}(ii,:) = accumarray(b1,mooring.u{i}(ii,:),[],@nanmean);
                mooring_v_temp{i}(ii,:) = accumarray(b1,mooring.v{i}(ii,:),[],@nanmean);
                
            end
            
            mooring_u{i} = mooring_u_temp{i};
            mooring_v{i} = mooring_v_temp{i};
            
            
        end
        break
    end
    num_sim_date = size(u_field_m_t,4);
    num_ver_layer = size(u_field_m_t,3);
    sim_3d_start_date=datenum(2006,1,1)-1;
    
    setting_depth = 0;
    while setting_depth == 1
        dh(1) = 0;
        dh(2:size(dz_new,2)+1) = dz_new ;
        
        % tracers beside W are at half the depth incerements
        
        for i=1:num_ver_layer+1
            
            sim_depth_w(i)=sum(dh(1:i));
            
        end
        
        for i=1:num_ver_layer
            
            sim_depth(i)=(sim_depth_w(i)+sim_depth_w(i+1))/2;
            
        end
        
        break
    end
    
    % changing U and V format and stroing them at given date and layer
    
    for sim_date  = 1:num_sim_date
        
        
        
        for m=1:num_ver_layer
            
            u_field{sim_date,m}=u_field_m_t(:,:,m,sim_date);
            v_field{sim_date,m}=v_field_m_t(:,:,m,sim_date);
            
        end
        
    end
    
    clear u_field_m_t v_field_m_t
    
    
    % Reshaping simulation data
    for n=1:num_sim_date
        for m=1:num_ver_layer
            u_field{n,m} = reshape(double(u_field{n,m}),size(u_field{n,m},1)*size(u_field{n,m},2),1);
            v_field{n,m} = reshape(double(v_field{n,m}),size(v_field{n,m},1)*size(v_field{n,m},2),1);
        end
    end
    
    
    
    % Reshaping the lon-lat
    
    lat_t_r=reshape(lat_t,size(lat_t,1)*size(lat_t,2),1);
    lon_t_r=reshape(lon_t,size(lon_t,1)*size(lon_t,2),1);
    
    display('starting the steps')
    for n=1:num_sim_date
        display(sprintf('mooting time step %d / 2801',n))
        
        sim_date = n+sim_3d_start_date;
        
        for m=1:num_ver_layer
            
            
            % interpolation and projection
            
            [x_t_r ,y_t_r ,u_z] = mfwdtran(mstruct, lat_t_r, lon_t_r, u_field{n,m});
            [x_t_r ,y_t_r ,v_z] = mfwdtran(mstruct, lat_t_r, lon_t_r, v_field{n,m});
            
            sim_u_surf = scatteredInterpolant(x_t_r ,y_t_r ,u_z,'linear','nearest');
            sim_v_surf = scatteredInterpolant(x_t_r ,y_t_r ,v_z,'linear','nearest');
            
            
            for p=1:length(mooring_date)
                
                for o=1:length(mooring_date{p})
                    
                    if mooring_date{p}(o) == sim_date
                        
                        [mooring_x ,mooring_y] = mfwdtran(mstruct, mooring_lat{p},mooring_lon{p});                        
                        
                        mooring_u_sim_temp{p}{o}(m,1) = sim_u_surf(mooring_x ,mooring_y);
                        mooring_v_sim_temp{p}{o}(m,1) = sim_v_surf(mooring_x ,mooring_y);
                        
                    end
                end
            end
            
            clear u_z v_z
            
        end
    end
    %     toc
    %
    
    % turning cell format to matrix again
    for p = 1:length(mooring_u_sim_temp)
        for o = 1:length(mooring_u_sim_temp{p})
            for m = 1:length(mooring_u_sim_temp{p}{o})
                
                mooring_u_sim{p}(m,o) =  mooring_u_sim_temp{p}{o}(m,1);
                mooring_v_sim{p}(m,o) =  mooring_v_sim_temp{p}{o}(m,1);
                
            end
        end
    end
    save ('mooring_uv_sim','mooring_date','mooring','sim_depth','mooring_v_sim','mooring_u_sim','mooring_u','mooring_v')
    break
end