clear all;clc,close all;

cd('/media/arash/SSD512/Post proc/inputs/T36/')

load('iu_field_m_t.mat')
load('iv_field_m_t.mat')
%load('/media/arash/SSD128/Post proc/inputs/constants/trajectory_start.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/ITP_ice_vel_filtered.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/coord_t.mat')
load('/media/arash/SSD128/Post proc/inputs/constants/msturuct.mat')


tic

% Reshaping the lon-lat
lat_t_r=reshape(lat_t,size(lat_t,1)*size(lat_t,2),1);
lon_t_r=reshape(lon_t,size(lon_t,1)*size(lon_t,2),1);

% constants
sim_start_date=datenum(2006,1,1)-1;
R = earthRadius;
dt=24*3600;

% reading from ITP_ice_vel instead of traj_start
% picking itps we need 1 11 25 35 44 53 62 66

itps_needed = [2,5,9,13,20,26,28,31];

% lets change it to itp 53 only that would be #26

% itps_needed = [26];


jj = 0;
for i = itps_needed
    
    jj = jj+1;
    itps_name{jj} =  itp_name_obs{i};
    itps_lat{jj} = itp_lat_obs{i}';
    itps_lon{jj} = itp_lon_obs{i}';
    itps_date{jj} = itp_date_obs{i}';
    
end

start_date = itps_date;
for n = 1:length(itps_date)
    
    end_date{n} = start_date{n}+30;
    
end

start_lon = itps_lon;
start_lat = itps_lat;

% ICs
current_lon=start_lon;
current_lat=start_lat;

for n=1:length(itps_date)
    
    current_lon1{n} = zeros(length(start_lon{n}),30);
    current_lat1{n} = zeros(length(start_lat{n}),30);
    current_date1{n} = zeros(length(start_date{n}),30);
    current_dist1{n} = zeros(length(start_date{n}),30);
    current_lon1{n}(:,1) = current_lon{n};
    current_lat1{n}(:,1) = current_lat{n};
    current_date1{n}(:,1) = itps_date{n};
    
end



for n=1:size(iu_field_m_t,3)
    
    %making the interpolation surface
    iv_field_t_r(:,:,n)=reshape(double(iv_field_m_t(:,:,n)),size(lat_t,1)*size(lat_t,2),1);
    iu_field_t_r(:,:,n)=reshape(double(iu_field_m_t(:,:,n)),size(lat_t,1)*size(lat_t,2),1);
    
    
    [x_t_r ,y_t_r ,iu_field_t_r_z(:,:,n)] = mfwdtran(mstruct,lat_t_r,lon_t_r,iu_field_t_r(:,:,n));
    [x_t_r ,y_t_r ,iv_field_t_r_z(:,:,n)] = mfwdtran(mstruct,lat_t_r,lon_t_r,iv_field_t_r(:,:,n));
    
    sim_surf_u=scatteredInterpolant(x_t_r,y_t_r,iu_field_t_r_z(:,:,n),'linear','nearest');
    sim_surf_v=scatteredInterpolant(x_t_r,y_t_r,iv_field_t_r_z(:,:,n),'linear','nearest');
    
    %setting date
    current_date=sim_start_date+n-1;
    
    for itp_n=1:length(current_lat1)
        for mm = 1:size(current_lon1{itp_n},1)
            for oo = 1:size(current_lon1{itp_n},2)
                
                if current_date == current_date1{itp_n}(mm,oo) && oo < 30
                    
                    current_date1{itp_n}(mm,oo+1) = current_date1{itp_n}(mm,oo)+1;
                    
                    [current_x{itp_n}(mm,oo),current_y{itp_n}(mm,oo)] = mfwdtran (mstruct,current_lat1{itp_n}(mm,oo),current_lon1{itp_n}(mm,oo));
                    
                    v_i = sim_surf_v(current_x{itp_n}(mm,oo),current_y{itp_n}(mm,oo));
                    u_i = sim_surf_u(current_x{itp_n}(mm,oo),current_y{itp_n}(mm,oo));
                    dnorth = dt*v_i;
                    deast = dt*u_i;
                    current_dist1{itp_n}(mm,oo+1) = sqrt(dnorth^2+deast^2);
                    
                    %linear aprox
                    
                    dlat = asin(dnorth/R);
                    current_lat1{itp_n}(mm,oo+1) = current_lat1{itp_n}(mm,oo) + rad2deg(dlat);
                    R_prime = R*cos(deg2rad(current_lat1{itp_n}(mm,oo)));
                    dlon = asin(deast/R_prime);
                    current_lon1{itp_n}(mm,oo+1) = current_lon1{itp_n}(mm,oo)+ rad2deg(dlon);
                    
                    
                    %                     % using haversine formula
                    %                     lat1(itp_n)=deg2rad(current_lat(itp_n));
                    %                     brng(itp_n)=atan2(deast(itp_n),dnorth(itp_n));
                    %                     next_lat(itp_n)=rad2deg(asin(sin(lat1(itp_n))*cos(dis(itp_n)/R) + cos(lat1(itp_n))*sin(dis(itp_n)/R)*cos(brng(itp_n))));
                    %                     next_lon(itp_n)=current_lon(itp_n) + rad2deg(atan2((sin(brng(itp_n))*sin(dis(itp_n)/R)*cos(lat1(itp_n))),(cos(dis(itp_n)/R)-sin(lat1(itp_n))*sin(deg2rad(next_lat(itp_n))))));
                    %
                    
                    
                    %                     sim_itp_loc{1,itp_n}(n,1)=current_date;
                    %                     sim_itp_loc{1,itp_n}(n,2)=current_lon(itp_n);
                    %                     sim_itp_loc{1,itp_n}(n,3)=current_lat(itp_n);
                    %                     sim_itp_loc{1,itp_n}(n,4)=current_lon1(itp_n);
                    %                     sim_itp_loc{1,itp_n}(n,5)=current_lat1(itp_n);
                    %                     current_lon(itp_n)=next_lon(itp_n);
                    %                     current_lat(itp_n)=next_lat(itp_n);
                    %                     current_lon1(itp_n)=next_lon1(itp_n);
                    %                     current_lat1(itp_n)=next_lat1(itp_n);
                    
                    
                end
            end
        end
    end
    n
end

itp_30d_lat = current_lat1
itp_30d_lon = current_lon1
itp_30d_date = current_date1
itp_30d_dist = current_dist1

save('sim_itp_30d','itp_30d_lon','itp_30d_lat','itp_30d_date','itp_30d_dist')
toc