function [lat_out,lon_out,i_area_grid] = Step11_comparison_36km_grid_timehistory(i_area_t,lat_t,lon_t,lat_lim,lon_lim,varargin)

% generate a grid

[lat1, lon1] = maptriml(lat_t,lon_t,lat_lim,lon_lim);

lat_ind1 = (lat1 == lat_lim(1));
lat_ind2 = (lat1 == lat_lim(2));
lon_ind1 = (lon1 == lon_lim(1));
lon_ind2 = (lon1 == lon_lim(2));

lat1(lat_ind1) = NaN;
lat1(lat_ind2) = NaN;
lon1(lon_ind1) = NaN;
lon1(lon_ind2) = NaN;

lon1(lat_ind1) = NaN;
lon1(lat_ind1) = NaN;
lat1(lon_ind1) = NaN;
lat1(lon_ind2) = NaN;

nancoord = (~isnan(lon1) + ~isnan(lat1) == 2);

lon1 = lon1(nancoord);
lat1 = lat1(nancoord);


% reshaping lat lon

lat=reshape(lat_t,size(lat_t,1)*size(lat_t,2),1);
lon=reshape(lon_t,size(lon_t,1)*size(lon_t,2),1);

%getting the indicies

for ii = 1:length(lat)
    if (logical(sum(floor(lat(ii)*10000)/10000 == floor(lat1(:)*10000)/10000))) ...
            + logical(sum((floor(lon(ii)*10000)/10000 == floor(lon1(:)*10000)/10000))) == 2
        lat_foo(ii) = lat(ii);
        lon_foo(ii) = lon(ii);
    else
        lat_foo(ii) = NaN;
        lon_foo(ii) = NaN;
    end
end

%n=dayss from start

n_days=size(i_area_t,3);

% cutting the data

for n=1:n_days
    
    ice_area{n} = double(i_area_t(:,:,n));
    ice_area{n}= reshape(ice_area{n},size(ice_area{n},1)*size(ice_area{n},2),1);
    ice_area{n} = ice_area{n}(~isnan(lat_foo));
    
end

lat_foo = lat_foo(~isnan(lat_foo));
lon_foo = lon_foo(~isnan(lon_foo));

% Pre-allocating sat_stat_ice



if nargin > 5
    
    lat_out = varargin{1};
    lon_out = varargin{2};
else
    
    lat_out = lat1;
    lon_out = lon1;
    
end

i_area_grid=zeros(length(lat_out),n_days);

for n=1:n_days
    
    for m = 1:length(lat_out)
        
        % interpolation
        sim_surf=scatteredInterpolant(lon_foo',lat_foo',ice_area{n},'linear','nearest');
        
        % reading inerpolation surface at points
        
        i_area_grid(m,n)=sim_surf(lon_out(m),lat_out(m));
        
    end
    n
end
